-- BonusRoll

local _,L = ... 

local BR = {}
BR.Frame = CreateFrame("Frame")

BR.Frame:SetScript("OnEvent", function(self,event,...) BR.events[event](...) end)

BR.Frame:RegisterEvent("BONUS_ROLL_RESULT")
BR.Frame:RegisterEvent("ADDON_LOADED")
BR.Frame:RegisterEvent("ENCOUNTER_END") -- existe avec START

BR.events = {}

-- Ma propre fenêtre de message
BR.TextFrame = CreateFrame("MessageFrame",nil,UIParent)
BR.TextFrame:SetHeight(300);
BR.TextFrame:SetWidth(400);
BR.TextFrame:Hide();
BR.TextFrame:SetPoint("CENTER", 0, 400);
BR.TextFrame:SetTimeVisible(20)
BR.TextFrame:SetFadeDuration(3)
BR.TextFrame:SetFont("Fonts\\ARIALN.TTF",60,"OUTLINE")

function BR.events.ADDON_LOADED(addon)
    if (addon ~= "BonusRoll") then
        return
    end
    BR:PrepareDatabase()
    -- BR:CreateOptionFrame()
    if(BonusRollDatabase.active == false) then -- à virer ? ça ne fait rien
        return
    end    
end

function BR.events.ENCOUNTER_END(id,nom,_,taille,succes)
	if succes == 1 then
		local BRmessage = L["Number of unsuccessful rolls so far: "]..BonusRollDatabase.money
		print(BRmessage)
		-- UIErrorsFrame:AddMessage(BRmessage, 0.0, 1.0, 0.0, 53, 60); 
		-- arguments : "message", red, green, blue, messageId, holdTime)
		BR.TextFrame:AddMessage(BRmessage)
		BR.TextFrame:Show()
	end
end

function BR.events.BONUS_ROLL_RESULT(loot_type, ...)
	-- print("événement BONUS_ROLL_RESULT détecté")
	-- print(loot_type)
	-- print(...)
	local BonusRollQuotient = BonusRollDatabase.money_total/BonusRollDatabase.item_total
	if loot_type == "money" then
		print(L["Gold !"])
		BonusRollDatabase.money_total = BonusRollDatabase.money_total+1
		BonusRollDatabase.money = BonusRollDatabase.money+1
		print(L["That's "]..BonusRollDatabase.money..L[" times in a row."])
	elseif loot_type == "item" then
		print(L["Yeah ! Loot !"])
		print(L["You rolled "]..BonusRollDatabase.money..L[" times unsuccessfully for that!"])
		print(L["Average: "]..BonusRollQuotient..L[" rolls per loot."])
		BonusRollDatabase.money=0
		BonusRollDatabase.item_total = BonusRollDatabase.item_total+1
	end
end

function BR:PrepareDatabase()
    -- Si la base de donnees n'existe pas deja
    if not BonusRollDatabase then
        BonusRollDatabase = {} -- nouvelle base
        BonusRollDatabase.active = true
        BonusRollDatabase.money = 0 -- nombre de rands ayant donné de l'or depuis le dernier item
		BonusRollDatabase.item_total = 0 -- nombre total de rands ayant donné un item
		BonusRollDatabase.money_total = 0 -- nombre total de rands ayant donné de l'or
		BonusRollDatabase.fail_total = 0 -- nombre total de rands foireux
    end
end

SLASH_BR1 = "/bonusroll"
SLASH_BR2 = "/br"
SlashCmdList["BR"] = function(msg)
	local BRmessage = L["Number of unsuccessful rolls so far: "]..BonusRollDatabase.money
	print(BRmessage)
	-- UIErrorsFrame:AddMessage(BRmessage, 0.0, 1.0, 0.0, 53, 60); 
	BR.TextFrame:AddMessage(BRmessage)
	BR.TextFrame:Show()
end